/*** Copyright (c), The Regents of the University of California            ***
 *** For more information please refer to files in the COPYRIGHT directory ***/
/* fileChmod.h - This file may be generated by a program or script
 */

#ifndef FILE_CHMOD_H
#define FILE_CHMOD_H

/* This is a low level file type API call */

#include "rods.h"
#include "rcMisc.h"
#include "procApiRequest.h"
#include "apiNumber.h"
#include "initServer.h"

#include "fileDriver.h"

typedef struct {
    fileDriverType_t fileType;
    rodsHostAddr_t addr;
    char fileName[MAX_NAME_LEN];
    int mode;
} fileChmodInp_t;
    
#define fileChmodInp_PI "int fileType; struct RHostAddr_PI; str fileName[MAX_NAME_LEN]; int mode;"

#if defined(RODS_SERVER)
#define RS_FILE_CHMOD rsFileChmod
/* prototype for the server handler */
int
rsFileChmod (rsComm_t *rsComm, fileChmodInp_t *fileChmodInp);
int
_rsFileChmod (rsComm_t *rsComm, fileChmodInp_t *fileChmodInp);
int
remoteFileChmod (rsComm_t *rsComm, fileChmodInp_t *fileChmodInp,
rodsServerHost_t *rodsServerHost);
#else
#define RS_FILE_CHMOD NULL
#endif

/* prototype for the client call */
int
rcFileChmod (rcComm_t *conn, fileChmodInp_t *fileChmodInp);

#endif	/* FILE_CHMOD_H */
