/*** Copyright (c), The Regents of the University of California            ***
 *** For more information please refer to files in the COPYRIGHT directory ***/
/* fileStage.h - This file may be generated by a program or script
 */

#ifndef FILE_STAGE_H
#define FILE_STAGE_H

/* This is a low level file type API call */

#include "rods.h"
#include "rcMisc.h"
#include "procApiRequest.h"
#include "apiNumber.h"
#include "initServer.h"

#include "fileDriver.h"

typedef struct {
    fileDriverType_t fileType;
    rodsHostAddr_t addr;
    char fileName[MAX_NAME_LEN];
    int flag;
} fileStageInp_t;
    
#define fileStageInp_PI "int fileType; struct RHostAddr_PI; str fileName[MAX_NAME_LEN]; int flag;"

#if defined(RODS_SERVER)
#define RS_FILE_STAGE rsFileStage
/* prototype for the server handler */
int
rsFileStage (rsComm_t *rsComm, fileStageInp_t *fileStageInp);
int
_rsFileStage (rsComm_t *rsComm, fileStageInp_t *fileStageInp);
int
remoteFileStage (rsComm_t *rsComm, fileStageInp_t *fileStageInp,
rodsServerHost_t *rodsServerHost);
#else
#define RS_FILE_STAGE NULL
#endif

/* prototype for the client call */
int
rcFileStage (rcComm_t *conn, fileStageInp_t *fileStageInp);

#endif	/* FILE_STAGE_H */
